# Peter Bengtsson <mail@peterbe.com>
# Constants for IssueTrackerProduct
#

true = 1
false = 0

# constants
ICON_LOCATION = 'misc_/IssueTrackerProduct'
ISSUETRACKER_METATYPE = 'Issue Tracker'
ISSUE_METATYPE = 'Issue Tracker Issue'
NOTIFYABLE_METATYPE = 'Issue Tracker Notifyable'
ISSUETHREAD_METATYPE = 'Issue Tracker Issue Thread'
NOTIFICATION_META_TYPE = 'Issue Tracker Notification'
NOTIFYABLEGROUP_METATYPE = 'Issue Tracker Notifyable Group'
NOTIFYABLECONTAINER_METATYPE = 'Issue Tracker Notifyable Container'
POP3ACCOUNT_METATYPE = 'Issue Tracker POP3 Account'
ACCEPTINGEMAIL_METATYPE = 'Issue Tracker Accepting Email'

# properties
DEFAULT_TYPES = ('general','bug report','missing page','feature request',\
                 'content request','usability','other')
DEFAULT_TYPE = DEFAULT_TYPES[0]
DEFAULT_URGENCIES = ('low','normal','high','critical')
DEFAULT_ALWAYS_NOTIFY = ()
DEFAULT_URGENCY = DEFAULT_URGENCIES[1]
DEFAULT_SECTIONS_OPTIONS = ('IssueTracker','General','Homepage','Other')
DEFAULT_SECTIONS = [DEFAULT_SECTIONS_OPTIONS[1]]
DEFAULT_WHEN_IGNORE_WORD = 'ignored'
DEFAULT_DISPLAY_DATE = '%d/%m %Y %H:%M'
DEFAULT_SITEMASTER_NAME = 'Issue Tracker Master'
DEFAULT_SITEMASTER_EMAIL = 'issuetracker@localhost'
DEFAULT_ODD_BGCOLOR = 'silver'
DEFAULT_EVEN_BGCOLOR = 'gainsboro'
DEFAULT_MANAGER_ROLES = ['Manager']
DEFAULT_DEFAULT_BATCH_SIZE = 25
DEFAULT_ISSUEPREFIX = ''
DEFAULT_NO_FILEATTACHMENTS = 0
DEFAULT_NO_FOLLOWUP_FILEATTACHMENTS = 0
DEFAULT_STATUSES = ('open','taken','on hold','rejected','completed')
DEFAULT_STATUSES_VERBS = ('open','take','put on hold','reject','complete')
DEFAULT_DISPLAY_FORMATS = ('plaintext','structuredtext')
DEFAULT_DEFAULT_DISPLAY_FORMAT = DEFAULT_DISPLAY_FORMATS[0]
DEFAULT_DISPATCH_ON_SUBMIT = 1
DEFAULT_RANDOMID_LENGTH = 4
DEFAULT_ALLOW_ISSUEATTRCHANGE = false
DEFAULT_STOP_CACHE = true
DEFAULT_ALLOW_SUBSCRIPTION = false
DEFAULT_PRIVATE_STATISTICS = true
DEFAULT_SHOW_CONFIDENTIAL_OPTION = false
DEFAULT_SHOW_HIDEME_OPTION = false
DEFAULT_SHOW_DOWNLOAD_BUTTON = false
DEFAULT_ENCODE_EMAILDISPLAY = false
#DEFAULT_STATUSES_TRANSLATION_VERBS = ('open|open','take|take',\
                                      #'put on hold|put on hold',\
                                      #'reject|reject','complete|complete')
#DEFAULT_STATUSES_TRANSLATION_ADJECTIVES =\
                    #('open|open','taken|taken','on hold|on hold',\
                     #'rejected|rejected','completed|completed')

NATIVE_PROPERTIES = ('title','types','urgencies','sections_options', 'defaultsections',
                     'when_ignore_word','display_date','sitemaster_name',
                     'sitemaster_email','odd_bgcolor','even_bgcolor','default_type',
                     'default_urgency','default_batch_size','issueprefix',
                     'statuses',#'notify_groups',
                     'name_cookiekey','email_cookiekey','display_format_cookiekey',
                     'display_formats','default_display_format','randomid_length',
                     'dispatch_on_submit',
                     'statuses_translation_verbs','statuses_translation_adjectives')

# Default constants that aren't available as properties
BRIEF_TITLE_MAX_LENGTH = 50

# special properties
DEFAULT_NOTIFYABLECONTAINER_ID = "global_notifyables"
DEFAULT_NOTIFYABLECONTAINER_TITLE = "Global IssueTracker notifyables"

# Keys
TEMPFOLDER_REQUEST_KEY = 'Tempfolder_fileattachments'
WHICHLIST_SESSION_KEY = 'WhichListView'

# Language constants
FAILURE_SUBJECT = 'Subject'
FAILURE_SUBJECT_DESC = 'You must at least enter a subject' 
NONAME_NOEMAIL = 'No name or email'
NAME_EMAIL_HIDDEN = 'Name and email hidden'
SORT_BY = 'Click to sort by'
SORT_REVERSE = 'Click one more time and the sorting will be reversed'



# File icons
ICON_ASSOCIATIONS={'bat':'bat.gif', 'chm':'chm.gif', 'dll':'dll.gif',
                   'doc':'doc.gif', 'exe':'exe.gif', 'gz':'gz.gif',
                   'tgz':'gz.gif',  'mpeg':'mpg.gif','mpg':'mpg.gif',
                   'pdf':'pdf.gif', 'ppt':'ppt.gif', 'py':'py.gif',
                   'pyw':'py.gif',  'pyc':'py.gif',  'reg':'reg.gif',
                   'tar':'tar.gif', 'txt':'txt.gif', 'nfo':'txt.gif',
                   'xls':'xls.gif', 'xml':'xml.gif', 'zip':'zip.gif',
                   'wav':'mpg.gif', 'mp3':'mp3.gif', 'ini':'ini.gif',
                   'gif':'gif.gif', 'jpg':'gif.gif', 'jpeg':'gif.gif',
                   'png':'gif.gif', 'avi':'mpg.gif', 'js':'js.gif',
                   'pyo':'py.gif',  'html':'html.gif','htm':'html.gif',
                   'psd':'psd.gif', 'fla':'fla.gif', 'swf':'swf.gif',
                   'zexp':'zope.gif'}

# cookies and sessions
NAME_COOKIEKEY = '__issuetracker_fromname'
EMAIL_COOKIEKEY = '__issuetracker_email'
DISPLAY_FORMAT_COOKIEKEY = '__issuetracker_display_format'
EMAILSTRING_COOKIEKEY = '__issuetracker_emailstring'
SORTORDER_COOKIEKEY = '__issuetracker_sortorder'
SORTORDER_REVERSE_COOKIEKEY = '__issuetracker_sortorder_reverse'

RECENTHISTORY_SEARCHKEY = '__issuetracker_recenthistory_searches'
RECENTHISTORY_ISSUEIDVISITKEY = '__issuetracker_recenthistory_issueidvisit'
RECENTHISTORY_ADDISSUEIDKEY = '__issuetracker_recenthistory_addissueid'
SHOW_FILTEROPTIONS_KEY = '__issuetracker_show_filteroptions'
FILTEROPTIONS_KEY = '__issuetracker_filteroptions'