import IssueTracker
import IssueTrackerNotifyables
"""IssueTracker Product"""
__version__ = '0.5.0b'


def initialize(context):
    """ Initialize IssueTracker product """
    try:
        context.registerClass(
            IssueTracker.IssueTracker,
            constructors = (
                # This is called when
                IssueTracker.manage_addIssueTrackerForm,
                # someone adds the product
                IssueTracker.manage_addIssueTracker         
                ),
            icon = "www/issuetracker.gif"

            )

        context.registerClass(
            IssueTrackerNotifyables.IssueTrackerNotifyableContainer,
            constructors = (
                # This is called when
                IssueTrackerNotifyables.manage_addNotifyableContainerForm,
                # someone adds the product
                IssueTrackerNotifyables.manage_addNotifyableContainer         
                ),
            icon = "www/issuetracker_notifyablecontainer.gif"

            )
        

        registerIcon('issue.gif')
        registerIcon('issuethread.gif')
        registerIcon('issuetracker_notifyable.gif')
        registerIcon('issuetracker_notifyablegroup.gif')
        registerIcon('notification.gif')
        registerIcon('issuetracker_pop3account.gif')
        registerIcon('issuetracker_acceptingemail.gif')
        registerIcon('issuetracker_logo_error.gif')
        registerIcon('bar.gif')
        icons = ('bat.gif', 'chm.gif', 'dll.gif', 'doc.gif', 'exe.gif',
                 'gz.gif',  'mpg.gif', 'pdf.gif', 'ppt.gif', 'py.gif',
                 'reg.gif', 'tar.gif', 'txt.gif', 'xls.gif', 'xml.gif',
                 'zip.gif', 'mp3.gif', 'ini.gif', 'gif.gif', 'js.gif',
                 'html.gif','psd.gif', 'fla.gif', 'swf.gif', 'zope.gif')
        for icon in icons:
            registerIcon(icon, epath='icons')
##        registerIcon('ascarrow.gif', {'.gif':''})
##        registerIcon('descarrow.gif', {'.gif':''})
##        registerIcon('invisiblearrow.gif', {'.gif':''})

##        context.registerHelp()
##        context.registerHelpTitle('IssueTrackerProduct Help')
    except:
        """If you can't register the product, tell someone. 
        
        Zope will sometimes provide you with access to "broken product" and
        a backtrace of what went wrong, but not always; I think that only 
        works for errors caught in your main product module. 
        
        This code provides traceback for anything that happened in 
        registerClass(), assuming you're running Zope in debug mode."""
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb




import OFS, App

def registerIcon(filename, idreplacer={}, epath=None):
    # A helper function that takes an image filename (assumed
    # to live in a 'www' subdirectory of this package). It 
    # creates an ImageFile instance and adds it as an attribute
    # of misc_.MyPackage of the zope application object (note
    # that misc_.MyPackage has already been created by the product
    # initialization machinery by the time registerIcon is called).
    objectid = filename
    if epath is not None:
        path = "www/%s/"%epath
    else:
        path = "www/"
    
    for k,v in idreplacer.items():
        objectid = objectid.replace(k,v)
    setattr(OFS.misc_.misc_.IssueTrackerProduct, 
            objectid, 
            App.ImageFile.ImageFile('%s%s' % (path, filename), globals())
            )
