## Script (Python) "sendIssue2Friends2"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=issueID, email_string, ignoreword='', added=1, from_sender=None, message_sender=None, REQUEST=None
##title=
##
""" 
This little script takes the information about an Issue and sends it to somebody.
Feel free to change at own will if you for example don't like the predefined 
text in this script.

use an email_string and a predefined message to send out
information to people about a new issue.
"""
from Products.PythonScripts.standard import url_quote_plus

request = context.REQUEST
mailhost = context.MailHost

issue = getattr(context, issueID)

if email_string.strip() == '' or email_string.strip() == ignoreword:
    request.RESPONSE.redirect(issue.absolute_url())
    
br = "\r\n"

fromname = context.get_cookie(context.getCookiekey('name'))
fromemail = context.get_cookie(context.getCookiekey('email'))
    
if fromname is None and fromemail is not None:
    fr = fromemail
elif fromname is not None and fromemail is not None:
    fr = "%s <%s>"%(fromname, fromemail)
else:
    fr = "%s <%s>"%(context.sitemaster_name, context.sitemaster_email)
    
to = context.preParseEmailString(email_string)

if added:
    subject = "%s: An issue has been added to your attention"%\
              context.getRoot().title_or_id()
else:
    subject = "%s: An Issue to your attention"%\
              context.getRoot().title_or_id()

if fromname is None:
    if added:
        msg = """An issue has been added to your attention at \
%s with the following title:"""%(context.getRoot().title) + br
    else:
        msg = """You have been asked to have a look at an issue in %s \
with the following title:"""%(context.getRoot().title) + br
else:
    if added:
        msg = fromname + """ has entered an Issue in %s and \
wanted you to know about it, with the following title:"""%(context.getRoot().title) + br
    else:
        msg = fromname + """ has asked you to have a look at an Issue in \
%s with the following title:"""%(context.getRoot().title) + br
            
msg = msg + ' "' + issue.title + '" ' + 2*br
msg = msg + "The Issue can be found at" + br
msg = msg + context.ActionURL(url=issue.absolute_url()) + br*3     
msg = msg + "Regards, " + context.sitemaster_name
   
if message_sender is not None:
    # I.e. used 'more options'
    msg = message_sender

if from_sender is not None and context.preParseEmailString(from_sender):
    fr = context.preParseEmailString(from_sender)
    

if REQUEST is None:
    return [msg, to, fr, subject]

 
body = string.join(("From: %s"%fr,
             "To: %s"%to,
             "Subject: %s"%subject,
             "",msg),br)

if to:
    if email_string != ignoreword:
        context.saveEmailstring(to)
    try:
        context.sendEmail(body, to, fr, subject)
        if added:
            qs = "?NewIssue=Send2Friends+Success"
        else:
            qs = "?IssueNotification=Send2Friends+Success"
        
    except:
        if added:
            qs = "?NewIssue=Send2Friends+Failed"
        else:
            qs = "?IssueNotification=Send2Friends+Failed"
else:
    if added:
        qs = "?NewIssue=Send2Friends+Failed+NoDestinators"
    else:
        qs = "?IssueNotification=Send2Friends+Failed+NoDestinators"

qs = '%s&email_string=%s'%(qs, email_string)
# Did they use 'more options'?
if message_sender is not None:
    umsg = url_quote_plus(message_sender)
    qs = '%s&MoreEmailOptions=1&message_sender=%s'%(qs, umsg)
    
if REQUEST is not None:
    request.RESPONSE.redirect(issue.absolute_url()+qs)
else:
    return qs